'  
'   Rebex Sample Code License
' 
'   Copyright 2026, REBEX CR s.r.o.
'   All rights reserved.
'   https://www.rebex.net/
' 
'   Permission to use, copy, modify, and/or distribute this software for any
'   purpose with or without fee is hereby granted.
' 
'   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'   OTHER DEALINGS IN THE SOFTWARE.
' 

Imports System
Imports Rebex.Net
Imports Rebex

' This sample asks a time server for time and uses the answer to update time
' on the local machine.
Class Synchronize

    Public Shared Sub Main()
            ' set the trial license key
            Rebex.Licensing.Key = Rebex.Samples.TrialKey.Key


        Dim args() As String = System.Environment.GetCommandLineArgs()

        If args.Length <> 2 Then
            Console.WriteLine("Usage: TimeSynchronize server.name")
            Console.WriteLine("Example: TimeSynchronize test.rebex.net")
            Return
        End If

        Console.WriteLine("Local time is {0}.", DateTime.Now)

        ' get NTP server response
        Dim client As Ntp = New Ntp(args(1))
        Dim response As NtpResponse = client.GetTime()

        ' show the time offset received
        Console.WriteLine("Moving local time by {0}.", response.TimeOffset.ToTimeSpan())

        ' adjust local time
        SystemClock.AdjustClock(response)

        Console.WriteLine("Corrected local time is {0}.", DateTime.Now)
    End Sub

End Class